package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.eam.core.eam_core.domain.EMMachineCategory;
import cn.ibizlab.eam.core.eam_core.filter.EMMachineCategorySearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMMachineCategory] 服务对象接口
 */
public interface IEMMachineCategoryService extends IService<EMMachineCategory>{

    boolean create(EMMachineCategory et) ;
    void createBatch(List<EMMachineCategory> list) ;
    boolean update(EMMachineCategory et) ;
    void updateBatch(List<EMMachineCategory> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EMMachineCategory get(String key) ;
    EMMachineCategory getDraft(EMMachineCategory et) ;
    boolean checkKey(EMMachineCategory et) ;
    boolean save(EMMachineCategory et) ;
    void saveBatch(List<EMMachineCategory> list) ;
    Page<EMMachineCategory> searchDefault(EMMachineCategorySearchContext context) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<EMMachineCategory> getEmmachinecategoryByIds(List<String> ids) ;
    List<EMMachineCategory> getEmmachinecategoryByEntities(List<EMMachineCategory> entities) ;
}


